aboutsummaryrefslogtreecommitdiff
path: root/wmenu_run
diff options
context:
space:
mode:
authorsewn <sewn@disroot.org>2024-03-10 18:07:46 +0300
committeradnano <me@adnano.co>2024-03-17 07:49:14 -0400
commitac25b0733885b545578092c5da74c9a3122529d6 (patch)
tree3dd50d4a5ad1e858f1e19572dad843a486b05277 /wmenu_run
parent9e9284666c9fcf3278ad17f98a247658db8b2269 (diff)
downloadwmenu-ac25b0733885b545578092c5da74c9a3122529d6.tar.gz
add wmenu_run script, similar to dmenu_run script
based off the works of sinanmohd, modified to be simpler and better to read, with shellcheck. Co-authored-by: sinanmohd <sinan@firemail.cc>
Diffstat (limited to 'wmenu_run')
-rwxr-xr-xwmenu_run35
1 files changed, 35 insertions, 0 deletions
diff --git a/wmenu_run b/wmenu_run
new file mode 100755
index 0000000..b243b38
--- /dev/null
+++ b/wmenu_run
@@ -0,0 +1,35 @@
+#!/bin/sh
+
+cachedir="${XDG_CACHE_HOME:-"$HOME/.cache"}"
+cache="$cachedir/wmenu_run"
+
+[ -d "$cachedir" ] || mkdir -p "$cachedir"
+
+uptodate() {
+ [ -f "$cache" ] || return 1
+ IFS=:
+ for path in $PATH; do
+ # non-POSIX
+ test "$path" -nt "$cache" && return 1
+ done
+ return 0
+}
+
+bins() {
+ IFS=:
+ for path in $PATH; do
+ for bin in "$path"/*; do
+ [ -x "$bin" ] && echo "${bin##*/}"
+ done
+ done
+}
+
+path() {
+ if uptodate; then
+ cat "$cache"
+ else
+ bins | sort -u | tee "$cache"
+ fi
+}
+
+path | wmenu "$@" | ${SHELL:-"/bin/sh"} &